/************************************************************************
 *
 * initdat.c  --  initialize header record of new data file
 *
 */

#include "cbtree.h"

void initdat(fd, btcp) /* initialize header record */

int  fd;
BTC *btcp;

{
   extern char *calloc();
   BTBLKHDR freespc;
   BT_BASE  btbase;
   int sz;  /* # bytes to pre-extend */
   char *cp;

   if (btcp->btvarlen)
   {
      freespc.eoflst =  (long)BASEBLK;
      sz =  BASEBLK;
   }
   else  /* fixed-length: pre-extend entire first record */
   {
      freespc.eoflst =  2L + (BASEBLK-1)/btcp->btdtalen;
      sz =  (freespc.eoflst-1) * btcp->btdtalen;
   }
   freespc.freelst = 0L;

   /* pre-extend first record */
   if ((cp = calloc(sz, SZCHAR)) == NULL)
      ckerror( CK_NOMEM, "123");
   if (lseek(fd, 0L, 0) == ERR)
      ckerror(- CK_SEEK, "124");
   if (write(fd, cp, sz) == ERR)
      ckerror(- CK_WRIT, "125");
   FREE(cp);
   putfhdr(fd, &freespc);

   /* set up rest of base blk */
   btbase.bb_cbver =   CBVER;   /* cbtree version number */
   btbase.bb_negver =  -CBVER;
   btbase.bb_numbtree= 0;      /* # btrees currently in this index file */
   btbase.bb_szinfo =  SZ_BT_INFO; /* sizeof each BT_INFO entry */
   btbase.bb_blksz  =  btcp->btdtalen;   /* data record size */
   btbase.bb_varlen =  btcp->btvarlen;   /* variable length rec flag */
   memset(btbase.bb_fill, NUL, sizeof(btbase.bb_fill));    /* clear it */
   if (lseek(fd, (long)SZBLKHDR, 0) == ERR)
      ckerror(- CK_SEEK, "126");
   if (write(fd, (char *)&btbase, SZ_BT_BASE) == ERR)
      ckerror(- CK_WRIT, "127");
}
